class Charline_1 extends Sketch
{
  float niveauMicro;

  // Variable qui va stocker notre fonte TTF
  RFont fonte;

  // Forme du texte
  RShape forme;
  RShape forme1;
  RShape forme2;
  RShape forme3;
  //RShape forme4;

  // Tableau de points
  RPoint[] points;
  RPoint[] points1;
  RPoint[] points2;
  RPoint[] points3;
  //RPoint[] points4;

  // Chaine de caractères à dessiner
  String texte = "un coup de";
  String texte1 = "vent jamais";
  String texte2 = "n'abolira";
  String texte3 = "le hasard";
  //String texte4 = "souffle";

  // Angle que l'on rajoute à l'angle calculé
  float angleOffset=0.0, angleOffsetCible=0.0;

  Charline_1(AudioInput audioInput) {
    in=audioInput;

    introName = "Charline";
  }  

  void data()
  {
    fonte = new RFont("charline_1/Verdana.ttf", 210, RFont.CENTER);
  }

  void setup()
  {
    super.setup();

    RCommand.setSegmentLength(8);
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    // Permet de centrer les caractères du texte dans la fenetre
    forme= fonte.toShape(texte);
    //forme = RG.centerIn(forme,this.g,50);
    forme1= fonte.toShape(texte1);
    //forme1 = RG.centerIn(forme1,this.g,50);
    forme2= fonte.toShape(texte2);
    forme3= fonte.toShape(texte3);

    // Récupère la liste de points
    points = forme.getPoints();
    points1 = forme1.getPoints();
    points2 = forme2.getPoints();
    points3 = forme3.getPoints();
    // points4 = forme4.getPoints();


    // Mode de dessin
    smooth();
    rectMode(CENTER);
  }

  void draw()
  {

    //translate(mouseX/2,mouseY/2);
    // Mise à jour des paramètres
    angleOffset += (angleOffsetCible-angleOffset)*0.2;  
    niveauMicro = 200*in.mix.level();// Sauvegarde en PDF (début)

    colorMode(HSB,360,100,100);
    float h=map(niveauMicro,200,width,110,250);
    //distance= dist(mouseX,mouseY,pmouseX,pmouseY);


    // Dessin du fond
    background(90,60,h);

    // Dessin texte
    /*fill(252);
     noStroke();
     pushMatrix();
     translate(width/2, height/2);
     forme.draw();
     popMatrix();
     */

    // Dessin des points
    noFill();
    mot_lignes(points,width/2,170);
    mot_lignes(points1,width/2,370);
    mot_lignes(points2,width/2,570);
    mot_lignes(points3,width/2,770);
  }

  void motif(float x, float y)
  {
    // Calcule l'angle entre la position de la souris et le point
    // du contour
    float angle = atan2(50*niveauMicro-y, 50*niveauMicro-x);

    /* stroke(10,40);
     pushMatrix();
     translate(x,y);
     rotate(angle+angleOffset);
     rect(0,0,mouseX,mouseY);
     popMatrix();
     */

    pushMatrix();
    translate(x,y);

    pushMatrix();
    rotate(angle);
    stroke(#366A48,150);
    line(0,0,random(50,51),random(40,41));
    popMatrix();


    pushMatrix();
    rotate(angle-PI/10);
    stroke(#366A00,60);
    line(0,0,10,0);
    popMatrix();


    noStroke();
    fill(10,30,niveauMicro,niveauMicro);
    ellipse(0,0,2,2);
    popMatrix();
  }
  void mot_lignes(RPoint[] points, float x, float y)
  {
    noFill();
    stroke(255);
    RPoint p;
    for (int i=0;i<points.length;i++)
    {
      p = points[i];
      motif(p.x+x, p.y+y);
    }
  }
}

