class Charline_2 extends Sketch
{
  // Variable qui va stocker notre fonte TTF
  RFont fonte;

  // Forme du texte
  RShape forme;
  RShape forme1;
  RShape forme2;
  RShape forme3;

  // Tableau de points
  RPoint[] points;
  RPoint[] points1;
  RPoint[] points2;
  RPoint[] points3;

  // Chaine de caractères à dessiner
  String texte = "ses doigts ";
  String texte1 = "tissent";
  String texte2 = "indéfiniment";
  String texte3 = "des routes";

  // Angle que l'on rajoute à l'angle calculé
  float angleOffset=0.0, angleOffsetCible=0.0;
  float h;


  Charline_2(AudioInput audioInput) {
    in=audioInput;

    introName = "Charline\nTexte tissage";
  }  

  void data()
  {
    fonte = new RFont("charline_2/Verdana.ttf", 180, RFont.CENTER);
  }

  void setup()
  {
    super.setup();
    // Permet de préciser le "découpage" de chaque lettre
    // Influe sur le nombre de points récupérés ensuite 
    RCommand.setSegmentLength(8);
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    // Permet de centrer les caractères du texte dans la fenetre
    forme= fonte.toShape(texte);
    //forme = RG.centerIn(forme,this.g,50);
    forme1= fonte.toShape(texte1);
    //forme1 = RG.centerIn(forme1,this.g,50);
    forme2= fonte.toShape(texte2);
    forme3= fonte.toShape(texte3);

    // Récupère la liste de points
    points = forme.getPoints();
    points1 = forme1.getPoints();
    points2 = forme2.getPoints();
    points3 = forme3.getPoints();


    // Mode de dessin
    smooth();
    rectMode(CENTER);
  }

  void draw()
  {
    // Mise à jour des paramètres
    angleOffset += (angleOffsetCible-angleOffset)*0.2;  



    // colorMode(HSB,360,100,100);
    h=map(smouseX,200,width,10,255);
    //distance= dist(smouseX,smouseY,psmouseX,psmouseY);


    // Dessin du fond
    background(h);

    // Dessin texte
    /*fill(252);
     noStroke();
     pushMatrix();
     translate(width/2, height/2);
     forme.draw();
     popMatrix();
     */

    // Dessin des points
    noFill();
    mot_lignes(points,width/2,300);
    mot_lignes(points1,width/2,400);
    mot_lignes(points2,width/2,500);
    mot_lignes(points3,width/2,600);
  }

  void motif(float x, float y)
  {
    // Calcule l'angle entre la position de la souris et le point
    // du contour
    float angle = atan2(smouseY-y, smouseX-x);

    /* stroke(10,40);
     pushMatrix();
     translate(x,y);
     rotate(angle+angleOffset);
     rect(0,0,smouseX,smouseY);
     popMatrix();
     */


    stroke(255-h,40);
    pushMatrix();
    translate(x,y);
    rotate(angle+angleOffset);
    line(random(-1,1),random(-1,1),width/2-smouseX,height/2-smouseY);
    popMatrix();
  }
  void mot_lignes(RPoint[] points, float x, float y)
  {
    noFill();
    stroke(0,100);
    RPoint p;
    for (int i=0;i<points.length;i++)
    {
      p = points[i];
      motif(p.x+x, p.y+y);
    }
  }
}

