class Jessie_1 extends Sketch {
  // Variable qui va stocker notre fonte TTF
  RFont fonte;

  // Tableau de points
  ArrayList points;
  //RPoint[][] points;

  // Formes
  RShape[] formes;
  // Chaine de caractères à dessiner
  //String texte = "Pour vivre heureux vivons cachés";
  String[] texte = {
    "Pour", "vivre", "heureux","vivons","cachés"
  };

  Jessie_1(AudioInput audioInput) {
    in=audioInput;
    introName = "Jessie";
  }  

  void data()
  {
    fonte = new RFont("jessie_1/HelveticaLight.ttf", 130, RFont.CENTER);
  }


  void setup()
  {
    super.setup();


    // Permet de préciser le "découpage" de chaque lettre
    // Influe sur le nombre de points récupérés ensuite 
    RCommand.setSegmentLength(10);//plus ou mois de points
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    // Permet de centrer les caractères du texte dans la fenetre
    //  RShape shape = fonte.toShape(texte);
    //  shape = RG.centerIn(shape,this.g,10);//centrer la forme geomtrique sur l'écran, MARGES autour de l'écran
    formes = new RShape[texte.length];
    for (int i=0;i<texte.length;i++)
    {
      formes[i] = fonte.toShape(texte[i]);
    }

    // Récupère la liste de points
    //points = shape.getPoints();
    points = new ArrayList();
    for (int i=0;i<texte.length;i++)
    {
      RPoint[] p = formes[i].getPoints();
      points.add( p );
      //    println(p.length);
    }



    // Mode de dessin
    smooth();
    rectMode(CENTER);
  }

  void draw()
  {

    float interligne = 120;
    float yTop = 200;
    background(255);
    for (int i=0;i<points.size();i++)
    {
      RPoint[] p = (RPoint[]) points.get(i);
      mot(p,width/2,yTop+interligne*i);
    }
  }


  void motif(float x, float y)
  {
    float rayonLampe = 80;  

    float distance = dist(smouseX, smouseY, x, y);
    float rayon = map(distance,0,300,0,20);
    float alpha = map(distance,0,rayonLampe,255,0);
    noFill();
    stroke(random(255),5,122-alpha,alpha);
    strokeWeight(random(2,8));
    ellipse(x,y,random(-5,6),random(-6,5));
  }

  void mot(RPoint[] points, float x, float y)
  {
    RPoint p;
    for (int i=0;i<points.length;i++)
    {
      p = points[i];
      motif(x+p.x,y+p.y);
    }
  }
}

