class Marion_1 extends Sketch {

  // Variable qui va stocker notre fonte TTF
  RFont fonte;

  // Tableau de points
  RPoint[] points;

  // Chaine de caractères à dessiner
  String texte = "urticant";

  PShape bot;
  PShape bot2;
  PShape bot3;
  PShape bot4;
  PShape bot5;
  PShape bot6;

  Marion_1(AudioInput audioInput) {
    in=audioInput;
    introName = "Marion";
  }  

  void data()
  {
    String folder = "marion_1/";
    
    fonte = new RFont(folder+"American Typewriter Bold BT.ttf", 200, RFont.CENTER);
    bot = loadShape(folder+"motif490.svg");
    bot2 = loadShape(folder+"motif.svg");
    bot3 = loadShape(folder+"motif439.svg");
    bot4 = loadShape(folder+"motif001784.svg");
    bot5 = loadShape(folder+"8.svg");
    bot6 = loadShape(folder+"motif0001784.svg");
  }

  void setup()
  {
    super.setup();

    // Permet de préciser le "découpage" de chaque lettre
    // Influe sur le nombre de points récupérés ensuite 
    RCommand.setSegmentLength(10);
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    // Permet de centrer les caractères du texte dans la fenetre
    RShape shape = fonte.toShape(texte);
    shape = RG.centerIn(shape,theApplet.g,50);

    // Récupère la liste de points
    points = shape.getPoints();

    smooth();
    rectMode(CENTER);
  }

  void draw()
  {
    background(255);
    RPoint p;
    for (int i=0;i<points.length;i++)
    {
      p = points[i];
      motif(p.x + width/2, p.y + height/2);
    }
  }

  void motif(float x, float y)
  {
    float distance = dist(smouseX, smouseY, x, y);
    float rayon = map(distance,0,300,10,40);
    float alpha = map(distance,0,500,255,40);
    float rotation = map(distance,0,300,0,360);

    stroke(0,alpha);
    noFill();
    //ellipse(x,y,5,5);

    /*
    pushMatrix();
     translate(x-2,y-2);
     rotate(radians(random(rotation)));
     scale(1);
     shape(bot2,-2*rayon/2,-2*rayon/2,rayon*2,rayon*2);
     popMatrix();
     */


    /*
    pushMatrix();
     translate(x+2,y+2);
     rotate(radians(random(rotation)));
     scale(1);
     shape(bot,-rayon/2,-rayon/2,rayon,rayon);
     popMatrix();
     */
    /*
    pushMatrix();
     translate(x+2,y+2);
     rotate(radians(random(rotation)));
     scale(1);
     shape(bot3,-rayon/2,-rayon/2,rayon,rayon);
     popMatrix();
     */

    pushMatrix();
    translate(x+2,y+2);
    rotate(radians(random(rotation)));
    scale(2);
    shape(bot6,-rayon/2,-rayon/2,rayon,rayon);
    popMatrix();
  }
}

