class Samuel_1 extends Sketch {

  PVector v;
  // Variable qui va stocker notre fonte TTF
  RFont fonte;

  // Forme du texte
  RShape forme;

  // Tableau de points
  RPoint[] points;

  // Chaine de caractères à dessiner
  String monTexte = "Load";
  int w;
  int h;

  Samuel_1(AudioInput audioInput)
  {
    in=audioInput;
    introName = "Samuel Bernou, Typo 3D";
    v = new PVector();
  }

  void data()
  {
    // charge la fonte depuis un fichier TTF
    fonte = new RFont("samuel_1/OCRAEXT.TTF", 200, RFont.CENTER);
  }

  void setup()
  {
    super.setup();

    w = width;
    h = height;
    // Mode de dessin
    smooth();
    stroke(0);

    // Permet de préciser le "découpage" de chaque lettre
    // Influe sur le nombre de points récupérés ensuite 
    RCommand.setSegmentLength(8);//defaut 10
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    // Permet de centrer les caractères du texte dans la fenetre
    forme= fonte.toShape(monTexte);
    forme = RG.centerIn(forme,theApplet.g,50);

    // Récupère la liste de points
    points = forme.getPoints();
  }

  void draw()
  {
    // Dessin du fond
    background(255);
    // Dessin des points
    noFill();
    //stroke(100,100,255);
    stroke(0);
    RPoint p;
    if(points != null) {
      for (int i=0;i<points.length;i++)
      {
        p = points[i];
        motif(p.x + smouseX, p.y + smouseY);
        //motif(p.x + width/2, p.y + height/2);
      }
    }
    float d = map(smouseX-width/2,-width/2,width/2,0,1);
    float dd = d;
    if (dd>=0.7)
      dd = 0.7;
    float w = map(dd,0,1,width,width/3);
    float h = map(dd,0,1,height,height/3);

    line(0,0,(width-w)/2,(height-h)/2);//haut gauche
    line(width,0,width-(width-w)/2,(height-h)/2);//haut droit
    line(0,height,(width-w)/2,height-(height-h)/2);//bas gauche
    line(width,height,width-(width-w)/2,height-(height-h)/2);
    rect((width-w)/2,(height-h)/2,w,h);
    // Dessin texte
    fill(255,150);
    //fill(255);
    noStroke();
    //stroke(0);

    pushMatrix();
    translate(smouseX, smouseY);
    //translate(width/2, height/2);
    forme.draw();
    popMatrix();
  }

  void motif(float x, float y)
  {
    //PVector v = new PVector(width/2-x,height/2-y); 
    v.x = width/2-x;
    v.y = height/2-y;
    float l = v.mag();
    v.normalize();
    float d = map(smouseX-width/2,-width/2,width/2,0,1);


    line(x,y,x+v.x*0.9*d*l,y+v.y*0.9*d*l);

    float dd = d;
    if (dd>=0.7)
      dd = 0.7;

    //if(d<0.7)
    {
      strokeWeight(0.5);
      pushMatrix();
      translate(width/2,height/2);

      popMatrix();
    }
  }
}

