class Virginie_2 extends Sketch
{
  float mx,my;
  float niveauMicro;
  boolean animation = false;
  float tempsBruitDebut = 0;
  float tempsBruit = 0;
  float dureeBruit = 5; // temps de repos
  boolean auto=false;
  float w=1000;
  // Variable qui va stocker notre fonte TTF
  RFont fonte;

  // Forme du texte
  RShape forme1;
  RShape forme2;
  RShape forme3;
  // Tableau de points
  RPoint[] points1;
  RPoint[] points2;
  RPoint[] points3;


  // Chaine de caractères à dessiner

  String texte1 = "Choisir entre";
  String texte2 = "s'écouter parler et";
  String texte3 = "se faire entendre.";



  // Angle que l'on rajoute à l'angle calculé
  float angleOffset=0.0, angleOffsetCible=0.0;

  PShape bot;


  Virginie_2(AudioInput audioInput) {
    in=audioInput;
    introName = "Virginie";
  }  

  void data()
  {
    bot = loadShape("virginie_2/motif.svg");
    fonte = new RFont("virginie_2/Georgia.ttf", 120, RFont.CENTER);
  }

  void setup()
  {
    super.setup();
    my=random(670,700);
    mx=random(290,300);
    auto=false;

    // Permet de préciser le "découpage" de chaque lettre
    // Influe sur le nombre de points récupérés ensuite
    RCommand.setSegmentLength(8); //distance entre deux points sur le texte
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    // Permet de centrer les caractères du texte dans la fenetre
    forme1= fonte.toShape(texte1);
    forme2= fonte.toShape(texte2);
    forme3= fonte.toShape(texte3);
    //forme = RG.centerIn(forme,this.g,50);

    // Récupère la liste de points
    points1 = forme1.getPoints();
    points2 = forme2.getPoints();
    points3 = forme3.getPoints();


    // Mode de dessin
    smooth();
    rectMode(CENTER);
  }

  void draw()
  {
    niveauMicro = 400*in.mix.level();
    //println(w);

    if (niveauMicro >= 200)
    {
      if (animation == false)
      {
        //mx=50;
        //my=50;
        //w=0;
        animation = true;
        //angleOffsetCible = PI; 
        tempsBruitDebut = millis();
      }
    }

    if (animation)
    {
      tempsBruit = (millis() - tempsBruitDebut)/1000;
      if(w>30) {
        w=w/2;
      }
      angleOffsetCible = random(0,4*PI);
      if (tempsBruit >= dureeBruit)
      {

        my=random(699,700);
        mx=random(699,700);
        animation = false;
        //angleOffsetCible = 0;
      }
    } 
    else {
      if(w<1000) {
        w=w*2;
      }
    }

    // Mise à jour des paramètres
    angleOffset += (angleOffsetCible-angleOffset)*0.2;

    // Dessin du fond
    background(255);

    // Dessin texte
    fill(252);
    noStroke();
/*
    pushMatrix();
    translate(width/2, height/2);
    forme1.draw();
    forme2.draw();
    forme3.draw();
    popMatrix();
*/

    if(!auto) {
      if(smouseX == 0) {
        mx = width/2;
      } 
      else {
        mx = smouseX;
      }
      if(smouseY == 0) {
        my = height/2;
      } 
      else {
        my = smouseY;
      }
    } 
    else {
      // mx+=random(-width/2,width/2);
      //my+=random(-height/2,height/2);

      //mx+=random(-30,30);
      //my+=random(-30,30);

      my=random(600,700);
      mx=random(100,200);

      if (mx<0) {
        mx=0;
      }
      if (mx>width) {
        mx=width;
      }
      if (my<0) {
        my=0;
      }
      if (my>height) {
        my=height;
      }
    }

    // Dessin des points
    noFill();
    RPoint p;
    for (int i=0;i<points1.length;i++)
    {
      p = points1[i];
      motif(p.x + width/2, p.y + 200);
    }
    for (int i=0;i<points2.length;i++)
    {
      p = points2[i];
      motif(p.x + width/2, p.y + 400);
    }
    for (int i=0;i<points3.length;i++)
    {
      p = points3[i];
      motif(p.x + width/2, p.y + 600);
    }
    /*fill(255,0,0);
     ellipse(mx,my,5,5);*/
  }


  void motif(float x, float y)
  {
    // Calcule l'angle entre la position de la souris et le point
    // du contour

    float angle = atan2(mx-y, my-x);
    // float angle = atan2(mouseY-y, mouseX-x);
    stroke(10,40);
    pushMatrix();
    translate(x,y);
    rotate(angle+angleOffset);
    //rotate(angle);
    strokeWeight(3);
    stroke(#8B5163,random(125));
    //stroke(0,random(50));
    //line(0,0,width*mx,height*my);

    float a = atan2(mx,my);

    line(0,0,cos(a)*w,sin(a)*w);

    // ellipse(0,0,10,10);

    //rect(0,0,2,60);
    //shape(bot,0,0,50,50);
    popMatrix();
  }
}

